use std::fs;
use clap::{App, Arg, ArgMatches, SubCommand};
use rust_util::util_clap::{Command, CommandError};
use crate::util::JsonKeyPair;
use crate::tx::{Transaction, TransactionBody};
use crate::engine::ContractEngine;
use crate::engine_plugin_credit::CreditContractIssueParameters;

pub struct CommandImpl;
impl Command for CommandImpl {
    fn name(&self) -> &str { "issue" }

    fn subcommand<'a>(&self) -> App<'a, 'a> {
        SubCommand::with_name(self.name()).about("Issue credit contract subcommand")
        .arg(Arg::with_name("name").long("name").short("n")
            .required(true).takes_value(true).help("Contract name")
        )
        .arg(Arg::with_name("receiver").long("receiver").short("r")
            .required(true).takes_value(true).help("Receiver")
        )
        .arg(Arg::with_name("credit").long("credit").short("c")
            .required(true).takes_value(true).help("Credit")
        )
        .arg(Arg::with_name("key").long("key").short("k")
            .required(true).takes_value(true).help("Key pair")
        )
    }
    
    fn run(&self, _arg_matches: &ArgMatches, sub_arg_matches: &ArgMatches) -> CommandError {
        let name = sub_arg_matches.value_of("name").unwrap();
        let receiver = sub_arg_matches.value_of("receiver").unwrap();
        let credit: u32 = sub_arg_matches.value_of("credit").unwrap().parse()?;
        let key = sub_arg_matches.value_of("key").unwrap();

        let key_json = fs::read_to_string(key)?;
        let (pri_key, pub_key) = JsonKeyPair::from_json(&key_json)?.to_key_pair()?;

        let parameters = CreditContractIssueParameters {
            name: name.into(),
            receiver: receiver.into(),
            credit,
        };
        let transaction_body = TransactionBody {
            timestamp: 0,
            nonce: "".into(),
            contract: "credit".into(),
            action: "issue".into(),
            parameters: serde_json::to_string(&parameters)?.into(),
        };
        let tx = Transaction::new(&transaction_body, &pri_key, &pub_key)?;

        information!("Create transaction: {:#?}", tx);

        let engine = ContractEngine::new();
        engine.execute(&tx)?;

        Ok(None)
    }
}
